

#include <stdio.h>
#include <stdlib.h>

int main(int argc, char *argv[])
{
  int M, N, P, Q, i, j, sum = 0;

  if(argc < 5) {
    fprintf(stderr, "Please give M, N, P, Q as arguments to make a MxN grid and divide it into PxQ blocks.\n");
    return -1;
  }

  M = atoi(argv[1]);
  N = atoi(argv[2]);
  P = atoi(argv[3]);
  Q = atoi(argv[4]);

  if(M<=0||N<=0||P<=0||Q<=0) {
    fprintf(stderr, "Give M, N, P, Q as numbers, greater than 0. \n");
    return -1;
  }

  int *decomposition_x = malloc(P*sizeof(int));
  int *decomposition_y = malloc(Q*sizeof(int));

  for(i = 0; i < P; i++) {
    decomposition_x[i] = M/P + (M%P>i);
  }
  for(i = 0; i < Q; i++) {
    decomposition_y[i] = N/Q + (N%Q>i);
  }

  for(i = 0; i < P; i++) {
    for(j = 0; j < Q; j++) {
      printf("%dx%d ", decomposition_x[i], decomposition_y[j]);
      sum+=decomposition_x[i]*decomposition_y[j];
    }
    printf("\n");
  }

  printf("Check: sum-N*M = %d-%d = %d\n", sum, N*M, sum-N*M);


  return 0;
}
